&& Tools_Object
&& (c) Gregory Adam 2008
*-------------------------------------------------------------------------------
#include	..\Include\Tools_Base.h
*-------------------------------------------------------------------------------
*--------------------------------------------------------------------------------
function Object_Create_Global(obj, ClassName, PARAMETERLIST08)

	local Success
	
	
	try
		Success = TOOLS_SESSION_GLOBAL.Object_Create_np(	@m.obj, ;
								m.ClassName, ;
								pcount()-2, ;
								PARAMETERLIST08_M ;
							)
	catch
		Success = FALSE
	
	endtry

	return m.Success
	
endfunc
*-------------------------------------------------------------------------------
*-------------------------------------------------------------------------------
function Object_Create(obj, ClassName, PARAMETERLIST08)

	return Object_Create_np(	@m.obj, ;
								m.ClassName, ;
								pcount()-2, ;
								PARAMETERLIST08_M ;
							)

endfunc
*-------------------------------------------------------------------------------
function Object_Create_np(obj, ClassName, np, PARAMETERLIST08)

	local Success
	Success = TRUE
	
	obj = null

	try
		
		do case
		case inlist(m.np, 0)
			obj = CreateObject(m.ClassName)
		
		case inlist(m.np, 1)
			obj = CreateObject(m.ClassName, m._p01)
		
		case inlist(m.np, 2)
			obj = CreateObject(m.ClassName, m._p01, m._p02)
		
		case inlist(m.np, 3)
			obj = CreateObject(m.ClassName, m._p01, m._p02, m._p03)
		
		case inlist(m.np, 4)
			obj = CreateObject(m.ClassName, m._p01, m._p02, m._p03, m._p04)
		
		case inlist(m.np, 5)
			obj = CreateObject(m.ClassName, m._p01, m._p02, m._p03, m._p04, m._p05)
		
		case inlist(m.np, 6)
			obj = CreateObject(m.ClassName, m._p01, m._p02, m._p03, m._p04, m._p05, m._p06)
		
		case inlist(m.np, 7)
			obj = CreateObject(m.ClassName, m._p01, m._p02, m._p03, m._p04, m._p05, m._p06, m._p07)
		
		case inlist(m.np, 8)
			obj = CreateObject(m.ClassName, m._p01, m._p02, m._p03, m._p04, m._p05, m._p06, m._p07, m._p08)
		
		case m.np < 0
			assert FALSE
			Success = FALSE
		
		otherwise
			assert FALSE
			Success = FALSE
		
		endcase
	
	catch
		if( !ISRUNTIME )
			=aerror(pp)
		endif
		
		assert FALSE
		Success = FALSE
	
	endtry
	
	do case
	case !m.Success
	
	case !inlist(vartype(m.obj), T_OBJECT)
		assert FALSE
		Success = FALSE
	
	endcase
	
	return m.Success
endfunc
*-------------------------------------------------------------------------------
function Object_Create_Property( ;
				ObjParent, PropertyName, ClassName, ;
				PARAMETERLIST08 ;
				)
	
	local obj
	
	do case
	case !Object_Create_np(@m.obj, m.ClassName, pcount()-3, ;
							PARAMETERLIST08_M ;
						)
		return FALSE
	
	case !AddProperty(m.ObjParent, m.PropertyName, m.obj)
		return FALSE
	
	endcase
	
	return TRUE
	
endfunc
*-------------------------------------------------------------------------------
function IsObject(obj, BaseClassName)
	
	return	inlist(vartype(m.obj), T_OBJECT) ;
		and	iif(empty(m.BaseClassName), TRUE, proper(m.obj.BaseClass) == proper(m.BaseClassName))
		

endfunc
*-------------------------------------------------------------------------------
