&& Tools
&& (c) Gregory Adam 2008
*-------------------------------------------------------------------------------
#include	.\Include\Tools_Base.h
*-------------------------------------------------------------------------------
function Tools
	
	local Success
	Success = TRUE
	
	=sys(3050,1, 64 * 1024 * 1024)
	=sys(3050,2, 32 * 1024 * 1024)
	
	with _screen
		.Icon =	TOOLS_PROJECT_ICON
		.WindowState = 2
		.Caption = 'Tools'
	
	endwith
	
	do case
	case !m.Success
	
	otherwise
		try
			set procedure to	TOOLS_PROCEDURES_BOOT, TOOLS_UTILITIES_BASE
		
		catch
			assert FALSE
			Success = FALSE
		
		endtry
	
	endcase
	
	do case
	case !m.Success
	
	case !Tools_Environment_Set()
		assert FALSE
		Success = FALSE

	case !Tools_Init()
		assert FALSE
		Success = FALSE
	
	endcase
	
endfunc
*-------------------------------------------------------------------------------
function Tools_Environment_Set()
	
	do case
	case ISRUNTIME
		Set assert Off
		set development off
		set Escape off
	otherwise
		set assert On
		set development on
		set Escape on
	endcase
	
	set Bell On
	set Compatible Off
	set Clock Status
	set fdow to 2
	set Fullpath On
	set fweek to 2
	set Notify off
	set Odometer to 100
	set Optimize On
	set Status bar On
	set TypeAhead to 16
	set UdfParms to Value
	set StrictDate to 0
	set KeyComp to Windows
endfunc
*--------------------------------------------------------------------------------