&& Tools_Base
&& (c) Gregory Adam 2008
*-------------------------------------------------------------------------------
#include	..\Include\Tools_Base.h
*-------------------------------------------------------------------------------
#if FALSE
	Call this if you use any of these in another project
	
	it will return FALSE if anything to include has been forgotten
	
#endif
function Tools_init()


	local Success
	Success = TRUE
	
	
	do case
	case !m.Success
	
	case PRIVATEDATASESSION
		assert FALSE
		Success = FALSE
		=MessageBox('Tools_init() can only be called from the default datasession', MB_ICONSTOP, 'Tools')
	
	case !ISRUNTIME and !Tools_DataSession_Set()
		assert FALSE
		Success = FALSE
		
	case !addProperty(eval(juststem([TOOLSGLOBAL])), justext([TOOLSGLOBAL]), createObject('empty'))
		assert FALSE
		Success = FALSE
	
	case !AddProperty(TOOLSGLOBAL, justext([TOOLS_SESSION_GLOBAL]), createobject('SessionGlobal'))
		assert FALSE
		Success = FALSE
		
	endcase
	

	do case
	case !m.Success
	
	case !Tools_Procedure_List_add([TOOLS_PROCEDURES])
		assert FALSE
		Success = FALSE
	

	endcase
	
	return m.Success
	
endfunc
*-------------------------------------------------------------------------------
function Tools_Procedure_List_add(sList) && Try all

	local Success
	Success = TRUE
	
	local i, aa[1], s
	
	for i = 1 to alines(aa, m.sList, 5, ',')
		s = m.aa[m.i]
		try
		
			set proc to (forceext(m.s, iif(ISRUNTIME, 'fxp', 'prg'))) additive
	
		catch
			assert FALSE
			Success = FALSE
			=MessageBox('Cannot set Procedure to :' + m.s, MB_ICONSTOP, 'Tools')
		endtry
	endfor
	
	return m.Success
	
endfunc
*-------------------------------------------------------------------------------
function Tools_DataSession_Set()

	set Ansi On
	set Autosave On
	set blocksize to 0
	set Carry Off
	set Century On
	set Collate to 'Machine'
	Set Confirm On
	&& set Database to (set('Database'))
	set date DMY
	set Deleted On
	set Exact On
	set Exclusive Off
	set Fixed Off
	set hours to 24
	set Lock Off
	set mark to '/'
	set memowidth to 100
	set Multilocks On
	set near on
	set Null Off
	set reprocess to automatic
	set Safety Off
	set Seconds On
	set Sysformats Off
	
	if( set('datasession') <= 1 )
		set Talk On
	else
		Set Talk Off
	endif
	
	set Unique Off
	set point to '.'
	set separator to ','
	set Decimals to 2
	
	local c, r, d, w
	w = 10
	c = year(date()) + m.w
	r = transf(mod(m.c,100))
	c = transf(int((m.c-100)/100))
	d = m.c + ' rollover ' + m.r
	set century to &d

endfunc
*--------------------------------------------------------------------------------
*--------------------------------------------------------------------------------



*================================================================================
*================================================================================
*================================================================================
define Class SessionGlobal	as	LIGHTWEIGHT_CLASS_BASE

*---------------------------------------------------------------------------
function Object_Create_np(obj, ClassName, np, PARAMETERLIST08)

	return Object_Create_np(	@m.obj, ;
								m.ClassName, ;
								m.np, ;
								PARAMETERLIST08_M ;
							)

endfunc
*-------------------------------------------------------------------------------
enddefine
*================================================================================
*================================================================================
*================================================================================

*================================================================================
*================================================================================
*================================================================================
*
* LIGHTWEIGHT_CLASS_BASE
*================================================================================
define class LIGHTWEIGHT_CLASS_BASE as Relation

	RELATIONCLASS_HIDDEN
	
	Name			= LIGHTWEIGHT_CLASS_BASE 

	DataSessionId	= 0
	
	CreationDateTime	= {:}
	
*--------------------------------------------------------------------------
protected function Init()
	
	this.CreationDateTime = datetime()
	this.DataSessionId = set('dataSession')
	return DoDefault()
endfunc
*--------------------------------------------------------------------------
protected function Message_Error(msg)
	
	=MessageBox(m.msg, MB_ICONSTOP, m.this.Class)
	
endfunc
*--------------------------------------------------------------------------
protected function Destroy()
	
	return DoDefault()
endfunc
*--------------------------------------------------------------------------
function Release()
	
	release (m.this)
endfunc
*--------------------------------------------------------------------------
enddefine
*================================================================================
*================================================================================
*================================================================================
